
(******************************************************************************
  Apache portable runtime API for FreePascal

  Note: I'm expect what it is very buggy... be careful ;)

  Zolotov Alex, 2007-2008
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 *****************************************************************************)

const
  APR_STATUS_IS_SUCCESS = 0;

type
  papr_byte_t = ^apr_byte_t;
  papr_int16_t = ^apr_int16_t;
  papr_uint16_t = ^apr_uint16_t;
  papr_int32_t = ^apr_int32_t;
  papr_uint32_t = ^apr_uint32_t;
  papr_int64_t = ^apr_int64_t;
  papr_uint64_t = ^apr_uint64_t;
  papr_size_t = ^apr_size_t;
  papr_ssize_t = ^apr_ssize_t;
  papr_off_t = ^apr_off_t;

  apr_byte_t = byte;
  apr_int16_t = smallint;
  apr_uint16_t = word;
  apr_int32_t = longint;
  apr_uint32_t = dword;
  apr_int64_t = int64;
  apr_uint64_t = qword;
  apr_size_t = sizeuint;
  apr_ssize_t = sizeint;
  apr_off_t = ptrint;
  apr_wait_t = longint;

  apr_status_t = longint;
  
  (** number of microseconds since 00:00:00 january 1, 1970 UTC *)
  apr_time_p = ^apr_time_t;
  apr_time_t = apr_int64_t;

  Papr_getopt_t  = ^apr_getopt_t;
  apr_getopt_p = ^apr_getopt_t;
  apr_getopt_t = record end;

type
  {* The fundamental pool type  }
  
  {*
   * Declaration helper macro to construct apr_foo_pool_get()s.
   *
   * This standardized macro is used by opaque (APR) data types to return
   * the apr_pool_t that is associated with the data type.
   *
   * APR_POOL_DECLARE_ACCESSOR() is used in a header file to declare the
   * accessor function. A typical usage and result would be:
   * <pre>
   *    APR_POOL_DECLARE_ACCESSOR(file);
   * becomes:
   *    APR_DECLARE(apr_pool_t *) apr_file_pool_get(apr_file_t *ob);
   * </pre>
   * @remark Doxygen unwraps this macro (via doxygen.conf) to provide 
   * actual help for each specific occurance of apr_foo_pool_get.
   * @remark the linkage is specified for APR. It would be possible to expand
   *       the macros to support other linkages.
    }
  apr_pool_p = ^apr_pool_t;
  apr_pool_t = record end;

type
  {* A function that is called when allocation fails.  }
  apr_abortfunc_t = function (retcode:longint):longint; cdecl;
  
  apr_array_header_p = ^apr_array_header_t;
  apr_array_header_t = record
    pool: apr_pool_p;
    elt_size: longint;
    nelts: longint;
    nalloc: longint;
    elts: longint;
  end;

(**
 * Structure for referencing files.
 *)
  apr_file_p = ^apr_file_t;
  apr_file_t  = record end;

