
(******************************************************************************
  Apache portable runtime API for FreePascal

  Note: I'm expect what it is very buggy... be careful ;)

  Zolotov Alex, 2007-2008
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 *****************************************************************************)

{$ifdef WIN32}

  type

     apr_uid_t = PSID;
{$else}

  type

     apr_uid_t = uid_t;
{$endif}
  {*
   * Structure for determining group ownership.
    }
{$ifdef WIN32}

  type

     apr_gid_t = PSID;
{$else}

  type

     apr_gid_t = gid_t;
{$endif}
  {*
   * Get the userid (and groupid) of the calling process
   * @param userid   Returns the user id
   * @param groupid  Returns the user's group id
   * @param p The pool from which to allocate working space
   * @remark This function is available only if APR_HAS_USER is defined.
    }
function apr_uid_current(out userid: apr_uid_t; out groupid: apr_gid_t; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_uid_current';

  {* @deprecated @see apr_uid_current  }
function apr_current_userid(out userid: apr_uid_t; out groupid: apr_gid_t; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_current_userid';

  {*
   * Get the user name for a specified userid
   * @param username Pointer to new string containing user name (on output)
   * @param userid The userid
   * @param p The pool from which to allocate the string
   * @remark This function is available only if APR_HAS_USER is defined.
    }
function apr_uid_name_get(out username: pchar; userid: apr_uid_t; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_uid_name_get';

  {* @deprecated @see apr_uid_name_get  }
function apr_get_username(out username: pchar; userid: apr_uid_t; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_get_username';

  {*
   * Get the userid (and groupid) for the specified username
   * @param userid   Returns the user id
   * @param groupid  Returns the user's group id
   * @param username The username to lookup
   * @param p The pool from which to allocate working space
   * @remark This function is available only if APR_HAS_USER is defined.
    }
function apr_uid_get(out userid: apr_uid_t; groupid: apr_gid_t; username: pchar; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_uid_get';

  {* @deprecated @see apr_uid_get  }
function apr_get_userid(out userid: apr_uid_t; groupid: apr_gid_t; username: pchar; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_get_userid';

  {*
   * Get the home directory for the named user
   * @param dirname Pointer to new string containing directory name (on output)
   * @param username The named user
   * @param p The pool from which to allocate the string
   * @remark This function is available only if APR_HAS_USER is defined.
    }
function apr_uid_homepath_get(out dirname: pchar; username: pchar; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_uid_homepath_get';

  {* @deprecated @see apr_uid_homepath_get  }
function apr_get_home_directory(out dirname: pchar; username: pchar; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_get_home_directory';

  {*
   * Get the group name for a specified groupid
   * @param groupname Pointer to new string containing group name (on output)
   * @param groupid The groupid
   * @param p The pool from which to allocate the string
   * @remark This function is available only if APR_HAS_USER is defined.
    }
function apr_gid_name_get(out groupname: pchar; groupid: apr_gid_t; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_gid_name_get';

  {* @deprecated @see apr_gid_name_get  }
function apr_group_name_get(out groupname: pchar; groupid: apr_gid_t; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_group_name_get';

  {* @deprecated @see apr_gid_name_get  }
function apr_get_groupname(out groupname: pchar; groupid: apr_gid_t; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_get_groupname';

  {*
   * Get the groupid for a specified group name
   * @param groupid Pointer to the group id (on output)
   * @param groupname The group name to look up
   * @param p The pool from which to allocate the string
   * @remark This function is available only if APR_HAS_USER is defined.
    }
function apr_gid_get(out groupid: apr_gid_t; groupname: pchar; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_gid_get';

  {* @deprecated @see apr_gid_get  }
function apr_get_groupid(out groupid: apr_gid_t; groupname: pchar; p: apr_pool_p): apr_status_t; cdecl; external libapr name 'apr_get_groupid';
