unit mxapr;

(******************************************************************************
  mxapr.pas

    Apache portable runtime API for FreePascal

    Note: I'm expect what it is very buggy... be careful ;)

  Zolotov Alex, 2007-2008
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 *****************************************************************************)

{$mode objfpc}
{$longstrings on}

{$IFDEF FPC}
{$PACKRECORDS C}
{$ENDIF}

interface
uses BaseUnix;

const
  libapr = 'apr-1';

{$i inc/apr_base.inc}
{$i inc/apr_thread_mutex.inc}
{$i inc/apr_allocator.inc}
{$i inc/apr_pools.inc}
{$i inc/apr_hash.inc}
{$i inc/apr_user.inc}
{$i inc/apr_file_info.inc}
{$i inc/apr_tables.inc}
{$i inc/apr_strings.inc}

function apr_initialize: apr_status_t; cdecl; external libapr name 'apr_initialize';
procedure apr_terminate; cdecl; external libapr name 'apr_terminate';

function apr_strerror(status: apr_status_t; buf: pchar; size: apr_size_t): pchar; cdecl;
  external libapr name 'apr_strerror';

implementation

end.
