
(******************************************************************************
    
  Subversion Client API for FreePascal

  @file svn_pools.h
  @brief Accessing SVN configuration files.
     
  Note: I'm expect what it is very buggy... be careful ;)

  Zolotov Alex, 2007-2008
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 *****************************************************************************)

//  const
//     SVN_ALLOCATOR_RECOMMENDED_MAX_FREE = 4096*1024;
  {* Wrapper around apr_pool_create_ex(), with a simpler interface.
   * The return pool will have an abort function set, which will call
   * abort() on OOM.
    }

  //function svn_pool_create_ex(parent_pool:apr_pool_p; allocator:papr_allocator_t):apr_pool_p;

{.$ifndef DOXYGEN_SHOULD_SKIP_THIS}
(* Const before type ignored *)

  //function svn_pool_create_ex_debug(parent_pool:apr_pool_p; allocator:papr_allocator_t; file_line:pchar):apr_pool_p;

{.$if APR_POOL_DEBUG}
  { was #define dname(params) para_def_expr }
  { argument types are unknown }
  { return type might be wrong }   
  function svn_pool_create_ex(pool,allocator : longint) : longint; cdecl; external libsvn_subr name 'svn_pool_create_ex';

{.$endif}
  { APR_POOL_DEBUG  }
{.$endif}
  { DOXYGEN_SHOULD_SKIP_THIS  }
  {* Create a pool as a subpool of @a parent_pool  }
  { was #define dname(params) para_def_expr }
  { argument types are unknown }
  { return type might be wrong }   
  function svn_pool_create(pool : apr_pool_p) : apr_pool_p;

  {* Clear a @a pool destroying its children.
   *
   * This define for @c svn_pool_clear exists for completeness.
    }
  procedure svn_pool_clear(pool: apr_pool_p);

  {* Destroy a @a pool and all of its children.
   *
   * This define for @c svn_pool_destroy exists for symmetry and
   * completeness.
    }
  procedure svn_pool_destroy(pool: apr_pool_p);
