unit mxsvn;

{$mode objfpc}
{$longstrings on}

(******************************************************************************
  mxsvn.pas

    Subversion Client API for FreePascal

    Note: I'm expect what it is very buggy... be careful ;)

  Zolotov Alex, 2007-2008
  zolotov-alex@shamangrad.net
  http://shamangrad.net/

 *****************************************************************************)

{$IFDEF FPC}
{$PACKRECORDS C}
{$ENDIF}

interface

uses mxapr;

const
  // libraries:
  libsvn_client = 'svn_client-1';
  libsvn_auth = 'svn_subr-1';
  libsvn_subr = 'svn_subr-1';
  libsvn_fs = 'svn_fs-1';

type
  // some extra types
  PFILE = Pointer;  // it is not pascal ^FILE, it is a C *FILE
  ppbyte = ^pbyte;
  
{$i inc/svn_types.inc}
{$i inc/svn_base.inc}
{$i inc/svn_time.inc}
{$i inc/svn_config.inc}
{$i inc/svn_cmdline.inc}
{$i inc/svn_pools.inc}
{$i inc/svn_client.inc}
{$i inc/svn_auth.inc}
{$i inc/svn_subr.inc}
{$i inc/svn_io.inc}

implementation

function svn_pool_create(pool : apr_pool_p) : apr_pool_p;
begin
  Result := svn_pool_create_ex(pool, nil);
end;

procedure svn_pool_clear(pool: apr_pool_p);
begin
  apr_pool_clear(pool);
end;

procedure svn_pool_destroy(pool: apr_pool_p);
begin
  apr_pool_destroy(pool);
end;

end.
